bl_info = {
    "name": "3D Direct Print",
    "author": "Gruppe 10",
    "version": (1, 0),
    "blender": (2, 83, 0),
    "location": "View3D > UI > 3D Direct Print ",
    "description": "Creates a .stl-file and a .gcode-file to directly slice",
    "warning": "",
    "doc_url": "",
    "category": "3D View"
}


import bpy
import os
import subprocess
import pprint 
from bpy.props import (StringProperty,
                       PointerProperty,
                       EnumProperty
                       )

from bpy.types import (Panel,
                       Operator,
                       AddonPreferences,
                       PropertyGroup,
                       )
                       


#Hier initialisieren wir die globale Variable printSetting
#in der später die printprofiles gespeichert werden sollen
printSetting = ""

#Hier initialisieren wir die globale Variable setDrucker
#in der später die Drucker Definitionen gespeichert werden sollen
setDrucker = ""

#Die Funktion change_setting(self,context) fungiert hier als Kontrollstruktur, die das Verhalten unserer dropdownlist
#für die verschiedenen Print Profiles bestimmt.
#Wir setzen hier global printSetting damit diese dann später mit dem Wert der lokalen Variable 
#printSetting überschrieben wird, die die command lines für die printprofile
#für die CuraEngine trägt.
def change_setting(self,context):
    global printSetting
    obj = bpy.context.object.my_tool
    if obj is not None:
        if obj.dropdown_box1 == 'DEXTRAFINE':
            printSetting = " -s layer_height=0.06 -s wall_thickness=1 -s wall_line_count=3 -s top_bottom_thickness=1 -s top_thickness=1 -s top_layers=17 -s bottom_thickness=1 -s bottom_layers=17 -s horizontal_expansion=0 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=195 -s material_bed_temperature=60 -s print_speed=50" 
        if obj.dropdown_box1 == 'DFINE':
            printSetting = " -s layer_height=0.1 -s wall_thickness=1 -s wall_line_count=3 -s top_bottom_thickness=1 -s top_thickness=1 -s top_layers=10 -s bottom_thickness=1 -s bottom_layers=10 -s horizontal_expansion=0 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=200 -s material_bed_temperature=60 -s print_speed=70"
        if obj.dropdown_box1 == 'DNORMAL':
            printSetting = " -s layer_height=0.15 -s wall_thickness=1 -s wall_line_count=3 -s top_bottom_thickness=1 -s top_thickness=1 -s top_layers=7 -s bottom_thickness=1 -s bottom_layers=7 -s horizontal_expansion=0 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=200 -s material_bed_temperature=60 -s print_speed=70"
        if obj.dropdown_box1 == 'DFAST':
            printSetting = " -s layer_height=0.2 -s wall_thickness=0.8 -s wall_line_count=3 -s top_bottom_thickness=0.8 -s top_thickness=0.8 -s top_layers=4 -s bottom_thickness=0.8 -s bottom_layers=4 -s horizontal_expansion=0 -s infill_density=15 -s infill_pattern=triangles -s material_print_temperature=205 -s material_bed_temperature=60 -s print_speed=70"
        if obj.dropdown_box1 == 'VEXTRAFINE':
            printSetting = " -s layer_height=0.06 -s wall_thickness=1.05 -s wall_line_count=3 -s top_bottom_thickness=1.05 -s top_thickness=1.05 -s top_layers=18 -s bottom_thickness=1.05 -s bottom_layers=18 -s horizontal_expansion=0 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=195 -s material_bed_temperature=60 -s print_speed=50"
        if obj.dropdown_box1 == 'VFINE':
            printSetting = " -s layer_height=0.1 -s wall_thickness=1.05 -s wall_line_count=3 -s top_bottom_thickness=1.05 -s top_thickness=1.05 -s top_layers=11 -s bottom_thickness=1.05 -s bottom_layers=11 -s horizontal_expansion=0 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=200 -s material_bed_temperature=60 -s print_speed=70"    
        if obj.dropdown_box1 == 'VNORMAL':
            printSetting = " -s layer_height=0.15 -s wall_thickness=1.05 -s wall_line_count=3 -s top_bottom_thickness=1.05 -s top_thickness=1.05 -s top_layers=7 -s bottom_thickness=1.05 -s bottom_layers=7 -s horizontal_expansion=0 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=200 -s material_bed_temperature=60 -s print_speed=70"          
        if obj.dropdown_box1 == 'EFINE':
            printSetting = " -s layer_height=0.1 -s wall_thickness=1.2 -s wall_line_count=3 -s top_bottom_thickness=1.2 -s top_thickness=1.2 -s top_layers=12 -s bottom_thickness=1.2 -s bottom_layers=12 -s horizontal_expansion=-0.02 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=200 -s material_bed_temperature=60 -s print_speed=30"
        if obj.dropdown_box1 == 'ENORMAL':
            printSetting = " -s layer_height=0.15 -s wall_thickness=1.2 -s wall_line_count=3 -s top_bottom_thickness=1.2 -s top_thickness=1.2 -s top_layers=8 -s bottom_thickness=1.2 -s bottom_layers=8 -s horizontal_expansion=-0.03 -s infill_density=20 -s infill_pattern=triangles -s material_print_temperature=200 -s material_bed_temperature=60 -s print_speed=30"        

#Die Funktion change_printer(self,context) fungiert hier als Kontrollstruktur, die das Verhalten unserer
#dropdownlist für die Printer bestimmt.  
#Wir setzen hier setDrucker global damit diese dann später mit dem Wert der lokalen Variable 
#setDrucker überschrieben wird, die die paths zu den definitionen des jeweils ausgewählten Druckers trägt.             
def change_printer(self, context):
    global setDrucker
    obj = bpy.context.object.my_tool
    if obj is not None:
        if obj.dropdown_box2 == 'ULTI5':
            setDrucker = 'resources\\definitions\\ultimaker_s5.def.json'
        if obj.dropdown_box2 == 'ULTI3':
            setDrucker = 'resources\\definitions\\ultimaker3.def.json'
        if obj.dropdown_box2 == 'ULTI2':
            setDrucker = 'resources\\definitions\\ultimaker2.def.json'
       
#Hier erstellen wir die Export und/Slice Funktion die an unseren Slice Button geknüpft ist
#in Form eines Operators    
class ExportToSTL(bpy.types.Operator):
    """Tooltip"""
    bl_idname = "myops.export_to_stl"
    bl_label = "Slice"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        main(context)
        return {'FINISHED'}

class MyProperties(bpy.types.PropertyGroup):
    #Filebrowser um den Cura Path einzugeben/auszuwählen wobei der Default Path
    #C:\\Program Files\\Ultimaker Cura 4.6\\ ist
    path : StringProperty(
        name="Absolute filepath",
        description="Path to Directory",
        default="C:\\Program Files\\Ultimaker Cura 4.6\\",
        maxlen=1024,
        subtype='FILE_PATH')
        
    #Dropdown Liste um das Print Profile auszuwählen  
    dropdown_box1: EnumProperty(
        items=(
            ('DEXTRAFINE', "Default Extra Fine", ""),
            ('DFINE', "Default Fine", ""),
            ('DNORMAL', "Default Normal", ""),
            ('DFAST',"Default Fast",""),
            ('VEXTRAFINE',"Visual Extra Fine",""),
            ('VFINE',"Visual Fine",""),
            ('VNORMAL',"Visual Normal",""),
            ('EFINE',"Engineering Fine",""),
            ('ENORMAL',"Engineering Normal","")    
        ),
        name="set printprofile",
        default='DNORMAL',
        description="Tooltip for the Dropdownbox",
        update=change_setting 
    )

    #Dropdown Liste um den Drucker auszuwählen
    dropdown_box2: EnumProperty(
        items=(
            ('ULTI5', "Ultimaker s5", ""),
            ('ULTI3', "Ultimaker 3", ""),
            ('ULTI2', "Ultimaker 2", "")
        ),
        name="set printer",
        default='ULTI3',
        description="Tooltip for the Dropdownbox",
        update= change_printer
    )
    
# UI unseres Print Panels
class PrintPanel(bpy.types.Panel):
    bl_label = "Print Panel"
    bl_idname = "DIRECT3D_PT_PrintPanel"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = '3D Direct Print'
    
    #Hier werden die einzelnen Elemente unseres UI Panels gezeichnet. 
    #Zu den Elementen gehören die beiden Dropdownlisten, der Filebrowser so wie der Slice Button
    def draw(self, context):
        layout = self.layout
        ob = context.object
        col = layout.column(align=True)
        row = layout.row()
        layout.prop(ob.my_tool, "dropdown_box1", text="Print profile")
        row = layout.row()
        layout.prop(ob.my_tool, "dropdown_box2", text="Printer")
        col.prop(ob.my_tool, "path", text="Cura Path")
        row = layout.row()
        row.operator("myops.export_to_stl")
        

# Operator
def main(context):
    #An dieser Stelle setzen wir die Umgebungsvariable CURA_ENGINE_SEARCH_PATH 
    #auf die beiden paths mit den printer definitions und den path zu den extrudern
    get_Printer_definitions = 'resources\\definitions'
    get_extruders = 'resources\\extruders' 
    usr_path = bpy.context.object.my_tool.path + get_Printer_definitions + ';' + bpy.context.object.my_tool.path + get_extruders 
    os.environ['CURA_ENGINE_SEARCH_PATH']= usr_path
    
    
    #speichert den Pfad der aktuellen Datei in die Variable blend_file_path
    blend_file_path = bpy.data.filepath
    #speichert die Directory von blend_file_path in die Variable directory
    directory = os.path.dirname(blend_file_path)
    #erstellt einen filepath für die kommende .stl datei
    target_file = os.path.join(directory,bpy.path.basename(bpy.context.blend_data.filepath)+ '.stl')
    #export die Datei zu .stl und weißt ihr den pfad target_file zu
    bpy.ops.export_mesh.stl(filepath=target_file)
    # erstellt einen filepath für die in der Curaengine commandline vorkommende .gcode datei
    gcode_file = os.path.join(directory,bpy.path.basename(bpy.context.blend_data.filepath)+ '.gcode')
    stlfile = '"'+ target_file +'"'
    gcodefile = '"'+ gcode_file +'"'
    
    #Wir überprüfen hier ob der vom User angegebene Cura Path mit unserem Default Path übereinstimmt.
    #Abhängig davon wird in den jeweiligen Cura Path reinnavigiert
    if(bpy.context.object.my_tool.path == "C:\\Program Files\\Ultimaker Cura 4.6\\"):
        os.chdir("C:\\Program Files\\Ultimaker Cura 4.6\\")
        printprofile = os.path.join('"C:\\Program Files\\Ultimaker Cura 4.6"' , setDrucker)
        #rufe die cmd auf und übergebe ihr den Slice command mit den parametern printprofile, stlfile und gcodefile
        os.system("start cmd /C"+ "CuraEngine slice -j "+ printprofile +" -l "+ stlfile +" -o "+ gcodefile + printSetting +"")
        
    else: 
        os.chdir(bpy.context.object.my_tool.path)
        printprofile = os.path.join(str(bpy.context.object.my_tool.path), setDrucker)
        printfile = '"'+printprofile+'"'
        os.system("start cmd /C"+ "CuraEngine slice -j "+ printfile +" -l "+ stlfile +" -o "+ gcodefile + printSetting +"")
        
        



#Hier sind alle Klassen aufgelistet, die in diesem Script Verwendung finden
classes = (
    MyProperties,
    ExportToSTL,
    PrintPanel
)

#Standardmäßige Registration so wie Unregistration für die Klassen und Properties in diesem Script       
def register():
    for cls in classes:
        bpy.utils.register_class(cls)
    bpy.types.Object.my_tool = PointerProperty(type=MyProperties)

    
    

def unregister():
   del bpy.types.Object.ob.my_tool
   for cls in reversed(classes):
       bpy.utils.unregister_class(cls)
    
       
if __name__ == "__main__":
    register()

    